import { Payload, JsonProps } from 'c5-envelope';
import { Encrypted, Decrypted } from '../schema/encrypted';
import { SymetricKey } from './key';
export interface Key {
    readonly id: string;
    readonly alg: string;
    encrypt(iv: string, message: string): string;
    decrypt(encrytped: string): string;
}
interface PayloadSealProps {
    readonly message: unknown;
    readonly reason?: string;
    readonly jsonProps?: JsonProps;
}
export declare const schema = "https://github.com/mabels/kleisimo/blob/main/schema/encrypted.ts";
export declare class PayloadSeal {
    readonly key: SymetricKey;
    constructor(key: SymetricKey);
    seal({ message, reason }: PayloadSealProps): Payload<Encrypted>;
    unseal(encrypted: Payload<Encrypted>): Payload<Decrypted> | undefined;
}
export {};
