"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const encrypt_1 = require("./encrypt");
const key_1 = require("./key");
test('wrap encryption envelope', () => __awaiter(void 0, void 0, void 0, function* () {
    const message = 'this is a test';
    const key = new key_1.SymetricKey({
        id: 'test-key',
        alg: 'chacha20-poly1305',
        hashSeed: 'test',
    });
    yield key.create();
    const payloadSeal = new encrypt_1.PayloadSeal(key);
    const encrypted = payloadSeal.seal({ message, reason: 'reason' });
    expect(encrypted.data.message).not.toEqual(message);
    expect(encrypted.data.reason).toEqual('reason');
    expect(encrypted.kind).toEqual(encrypt_1.schema);
    const decrypted = payloadSeal.unseal(encrypted);
    expect(decrypted.data.message).toEqual(message);
    expect(decrypted.data.reason).toEqual('reason');
    expect(decrypted.kind).toEqual(encrypt_1.schema);
    expect(payloadSeal.unseal({ kind: 'wurstbrot', data: {} })).toBeFalsy();
}));
//# sourceMappingURL=encrypt.test.js.map