/// <reference types="node" />
import * as crypto from 'crypto';
import baseX from 'base-x';
export declare const bs58: baseX.BaseConverter;
export interface SymetricKeyProp {
    readonly id?: string;
    readonly hashSeed?: string;
    readonly key?: string;
    readonly nounce?: string;
    readonly alg?: crypto.CipherCCMTypes;
    readonly keyLength?: number;
    readonly nounceLength?: number;
}
export declare class SymetricKey {
    id?: string;
    readonly hashSeed: string;
    keyBuffer?: Buffer;
    nounceBuffer?: Buffer;
    readonly alg: crypto.CipherCCMTypes;
    readonly keyLength: number;
    readonly nounceLength: number;
    constructor(prop: SymetricKeyProp);
    static create(props: SymetricKeyProp): Promise<SymetricKey>;
    create(): Promise<SymetricKey>;
    get key(): string;
    get nounce(): string;
    decrypt(dec: string): Buffer;
    encrypt(enc: string | Buffer, addition?: Buffer): string;
    hash(enc: string): string;
}
