"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const key_1 = require("./key");
test('key', () => __awaiter(void 0, void 0, void 0, function* () {
    const nounce = Buffer.alloc(12, 0xff).toString('base64');
    const key = Buffer.alloc(32, 0x01).toString('base64');
    const symKey = new key_1.SymetricKey({
        hashSeed: 'Hash',
        nounce,
        key,
    });
    expect(symKey.hashSeed).toBe('Hash');
    expect({ key: symKey.key, nounce: symKey.nounce }).toEqual({
        key,
        nounce,
    });
}));
test('en-decrypt', () => __awaiter(void 0, void 0, void 0, function* () {
    const key = new key_1.SymetricKey({
        hashSeed: 'Hash',
        nounce: Buffer.alloc(12, 0xff).toString('base64'),
        key: Buffer.alloc(32, 0x01).toString('base64'),
    });
    yield key.create();
    expect(key.encrypt('input')).not.toContain('input');
    expect(key.decrypt(key.encrypt('input')).toString()).toBe('input');
}));
test('hash', () => __awaiter(void 0, void 0, void 0, function* () {
    const key = new key_1.SymetricKey({
        hashSeed: 'Hash',
        nounce: Buffer.alloc(12, 0xff).toString('base64'),
        key: Buffer.alloc(32, 0x01).toString('base64'),
    });
    yield key.create();
    expect(key.hash('input')).toBe('AEJDPjgo535AwWJ2tEPt8KW91DDS9JiktH6hsQ2Xq6kLR');
    expect(key.hash(' in\nPut ')).toBe('AEJDPjgo535AwWJ2tEPt8KW91DDS9JiktH6hsQ2Xq6kLR');
}));
//# sourceMappingURL=key.test.js.map